ROUND equ 8
CATMULL_SHIFT equ 8
gouraud_triangle_z:

;----procedure drawing gouraud triangle with z coordinate
;----interpolation ( Catmull alghoritm )-----------------
;------------------in - eax - x1 shl 16 + y1 ------------
;---------------------- ebx - x2 shl 16 + y2 ------------
;---------------------- ecx - x3 shl 16 + y3 ------------
;---------------------- esi - pointer to Z-buffer--------
;---------------------- Z-buffer filled with dd variables
;---------------------- shifted CATMULL_SHIFT------------
;---------------------- edi - pointer to screen buffer---
;---------------------- stack : colors-------------------
;----------------- procedure don't save registers !!-----
.col1r equ ebp+4   ; each color as word
.col1g equ ebp+6   ; each z coordinate as word
.col1b equ ebp+8
.z1    equ ebp+10
.col2r equ ebp+12
.col2g equ ebp+14
.col2b equ ebp+16
.z2    equ ebp+18
.col3r equ ebp+20
.col3g equ ebp+22
.col3b equ ebp+24
.z3    equ ebp+26
.y_min equ [ebp+28]
.y_max equ [ebp+30]

.x1    equ word[ebp-2]
.y1    equ word[ebp-4]
.x2    equ word[ebp-6]
.y2    equ word[ebp-8]
.x3    equ word[ebp-10]
.y3    equ [ebp-12]

.dx12  equ dword[ebp-16]
.dz12  equ dword[ebp-20]
.dc12r equ dword[ebp-24]
.dc12g equ dword[ebp-28]
.dc12b equ [ebp-32]

.dx13  equ dword[ebp-36]
.dz13  equ dword[ebp-40]
.dc13r equ dword[ebp-44]
.dc13g equ dword[ebp-48]
.dc13b equ [ebp-52]

.dx23  equ dword[ebp-56]
.dz23  equ dword[ebp-60]
.dc23r equ dword[ebp-64]
.dc23g equ dword[ebp-68]
.dc23b equ [ebp-72]

.zz1   equ dword[ebp-76]
.c1r   equ dword[ebp-80]
.c1g   equ dword[ebp-84]
.c1b   equ dword[ebp-88]
.zz2   equ dword[ebp-92]
.c2r   equ dword[ebp-96]
.c2g   equ dword[ebp-100]
.c2b   equ dword[ebp-104]
;.zz1   equ dword[ebp-100]
;.zz2   equ dword[ebp-104]

.c1bM equ [ebp-88]
.c2bM equ [ebp-104]
.c1rM equ [ebp-80]
.c2rM equ [ebp-96]
.dc23bM equ [ebp-72]
.dc13bM equ [ebp-52]
.dc12bM equ [ebp-32]
.dc12rM equ [ebp-24]
.dc13rM equ [ebp-44]
.dc23rM equ [ebp-64]
if Ext=MMX
      emms
end if

       mov     ebp,esp
     ;  sub     esp,84
 .sort3:		  ; sort triangle coordinates...
       cmp     ax,bx
       jle     .sort1
       xchg    eax,ebx
       movq    xmm0,[.col1r]
       movq    xmm1,[.col2r]
       movq    [.col2r],xmm0
       movq    [.col1r],xmm1
 .sort1:
       cmp	bx,cx
       jle	.sort2
       xchg	ebx,ecx
       movq    xmm0,[.col3r]
       movq    xmm1,[.col2r]
       movq    [.col2r],xmm0
       movq    [.col3r],xmm1
       jmp .sort3
 .sort2:
       push	eax	     ; store in variables
       push	ebx
       push	ecx

	movups	xmm0,.y3		; check if at last only fragment
	pand	xmm0,[draw_thread_mask] ; of triangle is in visable area
	movd	xmm1,.y_min
	packssdw xmm0,xmm0
	pshuflw xmm2,xmm1,01010101b
	pshuflw xmm1,xmm1,0
	movdqa	xmm3,xmm0
	pcmpgtw xmm3,xmm2
	pcmpgtw xmm0,xmm1
	pxor	xmm0,xmm3
	pmovmskb eax,xmm0
	and	al,00111111b
	or	al,al
	jz	.gt_loop2_end


;         mov      edx,80008000h  ; eax,ebx,ecx are ANDd together into edx which means that
;         and      edx,ebx        ; if *all* of them are negative a sign flag is raised
;         and      edx,ecx
;         and      edx,eax
;         test     edx,80008000h  ; Check both X&Y at once
;         jne      .gt_loop2_end

       mov	bx,.y2	     ; calc deltas
       sub	bx,.y1
       jnz	.gt_dx12_make
       pxor	xmm0,xmm0
       push	dword 0
       movdqu	.dc12b,xmm0
       sub	esp,16
       jmp	.gt_dx12_done
  .gt_dx12_make:

	movsx	ebx,bx
	mov   eax,1 shl 15
	cdq
	idiv  ebx

	mov   cx,.x2
	sub   cx,.x1
	movsx ecx,cx
	imul  ecx,eax
	sar   ecx,15 - ROUND
	push  ecx

	mov	cx,word[.z2]
	sub	cx,word[.z1]
	movsx	ecx,cx
	imul	ecx,eax
	sar	ecx,15 - CATMULL_SHIFT
	push	ecx

	mov	cx,word[.col2r]
	sub	cx,word[.col1r]
	movsx	ecx,cx
	imul	ecx,eax
	sar	ecx,15 - ROUND
	push	ecx

	mov	cx,word[.col2g]
	sub	cx,word[.col1g]
	movsx	ecx,cx
	imul	ecx,eax
	sar	ecx,15 - ROUND
	push	ecx

	mov	cx,word[.col2b]
	sub	cx,word[.col1b]
	movsx	ecx,cx
	imul	ecx,eax
	sar	ecx,15 - ROUND
	push	ecx

   .gt_dx12_done:

       mov	bx,.y3	     ; calc deltas
       sub	bx,.y1
       jnz	.gt_dx13_make
       pxor	xmm0,xmm0
       push	dword 0
       movdqu	.dc13b,xmm0
       sub	esp,16
       jmp	.gt_dx13_done
    .gt_dx13_make:

	movsx	ebx,bx
	mov	eax,1 shl 15
	cdq
	idiv	ebx

	mov   cx,.x3
	sub   cx,.x1
	movsx ecx,cx
	imul  ecx,eax
	sar   ecx,15 - ROUND
	push  ecx

	mov	cx,word[.z3]
	sub	cx,word[.z1]
	movsx	ecx,cx
	imul	ecx,eax
	sar	ecx,15 - CATMULL_SHIFT
	push	ecx

	mov	cx,word[.col3r]
	sub	cx,word[.col1r]
	movsx	ecx,cx
	imul	ecx,eax
	sar	ecx,15 - ROUND
	push	ecx

	mov	cx,word[.col3g]
	sub	cx,word[.col1g]
	movsx	ecx,cx
	imul	ecx,eax
	sar	ecx,15 - ROUND
	push	ecx

	mov	cx,word[.col3b]
	sub	cx,word[.col1b]
	movsx	ecx,cx
	imul	ecx,eax
	sar	ecx,15 - ROUND
	push	ecx



 if 0

       mov	ax,.x3
       sub	ax,.x1
       cwde
       movsx	ebx,bx
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;      mov      .dx13,eax
       push	 eax

       mov	ax,word[.z3]
       sub	ax,word[.z1]
       cwde
       shl	eax,CATMULL_SHIFT
       cdq
       idiv	ebx
       push	eax

       mov	ax,word[.col3r]
       sub	ax,word[.col1r]
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
      ; mov      .dc13r,eax
       push	  eax
       mov	  ax,word[.col3g]
       sub	  ax,word[.col1g]
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
     ;  mov .dc13g,eax
       push	eax
       mov	ax,word[.col3b]
       sub	ax,word[.col1b]
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
      ; mov .dc13b,eax
       push	eax
 end if
   .gt_dx13_done:

       mov	bx,.y3	     ; calc deltas
       sub	bx,.y2
       jnz	.gt_dx23_make
      ; mov      .dx23,0
      ; mov      .dz23,0
      ; mov      .dc23r,0
      ; mov      .dc23g,0
      ; mov      .dc23b,0
       pxor	xmm0,xmm0
       push	dword 0
       movdqu	.dc23b,xmm0
       sub	esp,16

     ;  push     dword 0
     ;  push     dword 0
     ;  push     dword 0
     ;  push     dword 0
     ;  push     dword 0
       jmp	.gt_dx23_done
    .gt_dx23_make:

	movsx	ebx,bx
	mov	eax,1 shl 15
	cdq
	idiv	ebx

	mov   cx,.x3
	sub   cx,.x2
	movsx ecx,cx
	imul  ecx,eax
	sar   ecx,15 - ROUND
	push  ecx

	mov	cx,word[.z3]
	sub	cx,word[.z2]
	movsx	ecx,cx
	imul	ecx,eax
	sar	ecx,15 - CATMULL_SHIFT
	push	ecx

	mov	cx,word[.col3r]
	sub	cx,word[.col2r]
	movsx	ecx,cx
	imul	ecx,eax
	sar	ecx,15 - ROUND
	push	ecx

	mov	cx,word[.col3g]
	sub	cx,word[.col2g]
	movsx	ecx,cx
	imul	ecx,eax
	sar	ecx,15 - ROUND
	push	ecx

	mov	cx,word[.col3b]
	sub	cx,word[.col2b]
	movsx	ecx,cx
	imul	ecx,eax
	sar	ecx,15 - ROUND
	push	ecx




if 0



       mov	ax,.x3
       sub	ax,.x2
       cwde
       movsx	ebx,bx
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;      mov      .dx23,eax
       push	 eax

       mov	ax,word[.z3]
       sub	ax,word[.z2]
       cwde
       shl	eax,CATMULL_SHIFT
       cdq
       idiv	ebx
       push	eax

       mov	ax,word[.col3r]
       sub	ax,word[.col2r]
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
      ; mov     .dc23r,eax
       push	eax
       mov	ax,word[.col3g]
       sub	ax,word[.col2g]
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
     ;  mov .dc23g,eax
       push	eax
       mov	ax,word[.col3b]
       sub	ax,word[.col2b]
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
      ; mov .dc23b,eax
       push	eax
end if
   .gt_dx23_done:
       sub	esp,32

       movsx	eax,.x1 		   ; eax - cur x1
       shl	eax,ROUND		   ; ebx - cur x2
       mov	ebx,eax
       movsx	edx,word[.z1]
       shl	edx,CATMULL_SHIFT
       mov	.zz1,edx
       mov	.zz2,edx
       movzx	edx,word[.col1r]
       shl	edx,ROUND
       mov	.c1r,edx
       mov	.c2r,edx
       movzx	edx,word[.col1g]
       shl	edx,ROUND
       mov	.c1g,edx
       mov	.c2g,edx
       movzx	edx,word[.col1b]
       shl	edx,ROUND
       mov	.c1b,edx
       mov	.c2b,edx
       mov	cx,.y1
       cmp	cx,.y2
       jge	.gt_loop1_end

    .gt_loop1:
       pushad

       push	word .y_max
       push	word .y_min
       mov	edx,.c2r	      ; c2r,c2g,c2b,c1r,c1g,c1b - current colors
       sar	edx,ROUND
       push	dx
       mov	edx,.c2g
       sar	edx,ROUND
       push	dx
       mov	edx,.c2b
       sar	edx,ROUND
       push	dx
       sar	ebx,ROUND    ; x2
       push	bx
       mov	edx,.c1r
       sar	edx,ROUND
       push	dx
       mov	edx,.c1g
       sar	edx,ROUND
       push	dx
       mov	edx,.c1b
       sar	edx,ROUND
       push	dx
       sar	eax,ROUND
       push	ax	      ; x1
       push	cx	      ; y
       push	.zz2
       push	.zz1
       call	gouraud_line_z

       popad
if Ext >= MMX
       movq	mm0,.c1bM
       paddd	mm0,qword .dc13bM
       movq	.c1bM,mm0
       movq	mm1,.c2bM
       paddd	mm1,qword .dc12bM
       movq	.c2bM,mm1

       movq	mm0,.c1rM
       paddd	mm0,qword .dc13rM
       movq	.c1rM,mm0
       movq	mm1,.c2rM
       paddd	mm1,qword .dc12rM
       movq	.c2rM,mm1
else
       mov	edx,.dc13r
       add	.c1r,edx
       mov	edx,.dc13g
       add	.c1g,edx
       mov	edx,.dc13b
       add	.c1b,edx
       mov	edx,.dc12r
       add	.c2r,edx
       mov	edx,.dc12g
       add	.c2g,edx
       mov	edx,.dc12b
       add	.c2b,edx

       mov	edx,.dz13
       add	.zz1,edx
       mov	edx,.dz12
       add	.zz2,edx
end if
       add	eax,.dx13
       add	ebx,.dx12
       inc	cx
       cmp	cx,.y2
       jl	.gt_loop1

   .gt_loop1_end:
       mov	cx,.y2
       cmp	cx,.y3
       jge	.gt_loop2_end

       movsx	ebx,.x2 		   ; eax - cur x1
       shl	ebx,ROUND		   ; ebx - cur x2
       movsx	edx,word[.z2]
       shl	edx,CATMULL_SHIFT
       mov	.zz2,edx
       movzx	edx,word[.col2r]
       shl	edx,ROUND
       mov	.c2r,edx
       movzx	edx,word[.col2g]
       shl	edx,ROUND
       mov	.c2g,edx
       movzx	edx,word[.col2b]
       shl	edx,ROUND
       mov	.c2b,edx

    .gt_loop2:
       pushad

       push	word .y_max
       push	word .y_min
       mov	edx,.c2r	      ; c2r,c2g,c2b,c1r,c1g,c1b - current colors
       sar	edx,ROUND
       push	dx
       mov	edx,.c2g
       sar	edx,ROUND
       push	dx
       mov	edx,.c2b
       sar	edx,ROUND
       push	dx
       sar	ebx,ROUND    ; x2
       push	bx
       mov	edx,.c1r
       sar	edx,ROUND
       push	dx
       mov	edx,.c1g
       sar	edx,ROUND
       push	dx
       mov	edx,.c1b
       sar	edx,ROUND
       push	dx
       sar	eax,ROUND
       push	ax	      ; x1
       push	cx	      ; y
       push	.zz2
       push	.zz1
       call	gouraud_line_z

       popad

if Ext >= MMX
       movq	mm0,.c1bM
       paddd	mm0,qword .dc13bM
       movq	.c1bM,mm0
       movq	mm1,.c2bM
       paddd	mm1,qword .dc23bM
       movq	.c2bM,mm1

       movq	mm0,.c1rM
       paddd	mm0,qword .dc13rM
       movq	.c1rM,mm0
       movq	mm1,.c2rM
       paddd	mm1,qword .dc23rM
       movq	.c2rM,mm1
else
       mov	edx,.dc13r
       add	.c1r,edx
       mov	edx,.dc13g
       add	.c1g,edx
       mov	edx,.dc13b
       add	.c1b,edx
       mov	edx,.dc23r
       add	.c2r,edx
       mov	edx,.dc23g
       add	.c2g,edx
       mov	edx,.dc23b
       add	.c2b,edx
       mov	edx,.dz13
       add	.zz1,edx
       mov	edx,.dz23
       add	.zz2,edx
end if
       add	eax,.dx13
       add	ebx,.dx23
       inc	cx
       cmp	cx,.y3
       jl	.gt_loop2
   .gt_loop2_end:

       mov	esp,ebp
ret 28
gouraud_line_z:

;----------------- procedure drawing gouraud line
;----------------- with z coordinate interpolation
;----------------- esi - pointer to Z_buffer
;----------------- edi - pointer to screen buffer
;----------------- stack:
.z1  equ dword[ebp+4]	; z coordiunate shifted left CATMULL_SHIFT
.z2  equ dword[ebp+8]
.y   equ word[ebp+12]
.x1  equ ebp+14
.c1b equ ebp+16
.c1g equ ebp+18
.c1r equ ebp+20
.x2  equ ebp+22
.c2b equ ebp+24
.c2g equ ebp+26
.c2r equ ebp+28
.y_min equ [ebp+30]
.y_max equ [ebp+32]

.dz	equ dword[ebp-4]
.dc_b	equ [ebp-8]
.dc_g	equ dword[ebp-12]
.dc_r	equ [ebp-16]
.c_z	equ dword[ebp-20]


	mov	  ebp,esp

	mov	ax,.y
	cmp	ax,.y_min
	jl	.gl_quit
	cmp	ax,.y_max
	jge	.gl_quit

	mov	eax,dword[.x1]
	cmp	ax,word[.x2]
	je	.gl_quit
	jl	@f
	movq	mm0,[.x1]
	movq	mm1,[.x2]
	movq	[.x1],mm1
	movq	[.x2],mm0

	movd	mm3,.z1
	movd	mm4,.z2
	movd	.z1,mm4
	movd	.z2,mm3
   @@:
	mov	ax,[xres_var]
	cmp	word[.x1],ax
	jge	.gl_quit
	cmp	word[.x2],0
	jle	.gl_quit

	mov	bx,word[.x2]	  ; dz = z2-z1/x2-x1
	sub	bx,word[.x1]
	movsx	ebx,bx
	mov   eax,1 shl 15
	cdq
	idiv  ebx
	mov   ecx,.z2
	sub   ecx,.z1
	imul  ecx,eax
	sar   ecx,15
	push  ecx

	mov	cx,word[.c2b]
	sub	cx,word[.c1b]
	movsx	ecx,cx
	imul	ecx,eax
	sar	ecx,15 - ROUND
	push	ecx
;        movq    xmm0,[.c1b]
;        movq    xmm1,[.c2b]
;        pxor    xmm2,xmm2
;        punpcklwd xmm0,xmm2
;        punpcklwd xmm1,xmm2
;        psubd   xmm1,xmm0
;        pslld   xmm1,ROUND
;        movd    xmm3,eax
;        pshufd  xmm3,xmm3,0
;        pmullssd  xmm3,xmm1
;        psrad   xmm3,15
;        pshufd  xmm3,xmm3,11000110b
;        movq    .dc_r,xmm3
;        psrldq  xmm3,8
;        movd    .dc_b,xmm3
;        sub     esp,12

	mov	cx,word[.c2g]
	sub	cx,word[.c1g]
	movsx	ecx,cx
	imul	ecx,eax
	sar	ecx,15 - ROUND
	push	ecx


	mov	cx,word[.c2r]
	sub	cx,word[.c1r]
	movsx	ecx,cx
	; dc_r = c2r-c1r/x2-x1
	imul	ecx,eax
	sar	ecx,15 - ROUND
	push	ecx


	cmp	word[.x1],0	; clipping on function
	jg	@f
	mov	eax,.dz
	movsx	ebx,word[.x1]
	neg	ebx
	imul	ebx
	add	.z1,eax
	mov	word[.x1],0

	mov	eax,.dc_r
	imul	ebx
	sar	eax,ROUND
	add	word[.c1r],ax

	mov	eax,.dc_g
	imul	ebx
	sar	eax,ROUND
	add	word[.c1g],ax

	mov	eax,.dc_b
	imul	ebx
	sar	eax,ROUND
	add	word[.c1b],ax

      @@:
	mov	ax,[xres_var]
	cmp	word[.x2],ax  ;SIZE_X
	jl	@f
	mov	word[.x2],ax  ;SIZE_X
     @@:
	sub	esp,128      ; calculate memory begin
	movzx	edx,[xres_var]	;SIZE_X       ; in buffers
	movzx	eax,.y
	mul	edx
	movzx	edx,word[.x1]
	add	eax,edx
	shl	eax,2
	add	edi,eax
	add	esi,eax

	mov	cx,word[.x2]
	sub	cx,word[.x1]
	movzx	ecx,cx


      pxor	xmm3,xmm3
      mov	ebx,.z1  ; ebx -> cur z
      movq	xmm1,[.c1b]
      punpcklwd xmm1,xmm3
      pslld	xmm1,ROUND
      movdqu	xmm2,.dc_r
      shufps	xmm2,xmm2,11000110b

   ;   movd      xmm7,ebx    ;;
   ;   movd      xmm6,.dz    ;;
   .ddraw:
   ;   movd      xmm5,[esi]  ;;
   ;   pcmpgtd   xmm5,xmm7   ;;
     cmp	ebx,dword[esi]
     jge	@f
     mov	dword[esi],ebx
     movdqa	xmm0,xmm1
     psrld	xmm0,ROUND
     pshufd	xmm0,xmm0,11000110b
     packssdw	xmm0,xmm0
     packuswb	xmm0,xmm0
   ;   movd       xmm4,[edi] ;;
   ;   pand       xmm5,xmm4  ;;
   ;   por        xmm5,xmm0  ;;
      movd	 [edi],xmm0

   @@:
     add	esi,4
     add	edi,4
   ;  paddd      xmm7,xmm6   ;;''
     add	ebx,.dz
     paddd	xmm1,xmm2
     sub	ecx,1
     or 	ecx,ecx
     jnz	.ddraw


   .gl_quit:

     mov       esp,ebp
ret 30
