ROUND2 equ 10

slices_tri_var:
;  Procedure calculate variable slices  buffer, wich describes depth
;  history of each filled screen pixel. It means pixel, that has not
;  zeroed counter in counter buff.
;  ----------------in - eax - x1 shl 16 + y1 -----------------------
;  -------------------- ebx - x2 shl 16 + y2 -----------------------
;  -------------------- ecx - x3 shl 16 + y3 -----------------------
; --------------------- edi - pointer to var sli pointers buff -----
; --------------------- esi - pointer to counter buffer ------------
;  -------------------- xmm0 - lo -> hi z1, z2, z3 as dword float --
;---------------------- xmm5 - lo -> hi y_min, y_max, x_min, x_max -
;-                      as dword integers --------------------------
.stvx1     equ [ebp-2]
.stvy1     equ [ebp-4]
.stvx2     equ [ebp-6]
.stvy2     equ [ebp-8]
.stvx3     equ [ebp-10]
.stvy3     equ [ebp-12]

.stvdx12   equ dword[ebp-20]
.stvdx13   equ dword[ebp-24]
.stvdx23   equ dword[ebp-28]
.stvdz12   equ dword[ebp-32]
.stvdz13   equ dword[ebp-36]
.stvdz23   equ dword[ebp-40]
.stvzz2    equ [ebp-44]
.stvzz1    equ [ebp-48]
.stvz3     equ [ebp-56]
.stvz2     equ [ebp-60]
.stvz1     equ [ebp-64]
.stvptr_buff equ [ebp-68] ; buffer of pointers, points on slices
.stvcnt_buff equ [ebp-72]
.x_max       equ [ebp-84]
.x_min       equ [ebp-88]
.y_max       equ [ebp-92]
.y_min       equ [ebp-96]


       push    ebp
       mov     ebp,esp
       sub     esp,128
       and     ebp,0xfffffff0
      .stvsort2:
        cmp     ax,bx
        jle     .stvsort1
        xchg    eax,ebx
        shufps  xmm0,xmm0,11100001b
      .stvsort1:
        cmp     bx,cx
        jle     .stvsort3
        xchg    ebx,ecx
        shufps  xmm0,xmm0,11011000b
        jmp     .stvsort2
      .stvsort3:
        mov     .stvy1,eax            ; store triangle coordinates in user friendly variables
        mov     .stvy2,ebx
        mov     .stvy3,ecx


        movaps  .stvz1,xmm0
        mov     .stvcnt_buff,esi
        mov     .stvptr_buff,edi

    movdqa   .y_min,xmm5
if 1                            ; check if at last only fragment
   packssdw xmm5,xmm5       ; of triangle is in visable area
   pshuflw  xmm5,xmm5,11011000b
   movdqu   xmm7,.stvy3
   movdqa   xmm6,xmm5
   pshufd   xmm5,xmm5,0  ; xmm5 lo-hi -> broadcasted y_min, x_min
   pshufd   xmm6,xmm6,01010101b ;xmm6 -> brd y_max x_max
   movdqa   xmm4,xmm7
   pcmpgtw  xmm7,xmm5
   pcmpgtw  xmm4,xmm6
   pxor     xmm7,xmm4
   pmovmskb eax,xmm7
   and      eax,0x00aaaaaa
   or       eax,eax
   jz       .stvloop2_end
end if
         mov      edx,80008000h  ; eax,ebx,ecx are ANDd together into edx which means that
         and      edx,ebx        ; if *all* of them are negative a sign flag is raised
         and      edx,ecx
         and      edx,eax
         test     edx,80008000h  ; Check both X&Y at once
         jne      .stvloop2_end

        mov     bx,.stvy2       ; calc delta 12
        sub     bx,.stvy1
        jnz     .stvdx12_make
        mov     .stvdx12,0
        mov     .stvdz12,0
        jmp     .stvdx12_done
   .stvdx12_make:
        mov     ax,.stvx2
        sub     ax,.stvx1
        cwde
        movsx   ebx,bx
        shl     eax,ROUND2
        cdq
        idiv    ebx
        mov     .stvdx12,eax

        movss    xmm1,.stvz2
        cvtsi2ss xmm2,ebx
        subss    xmm1,.stvz1
        divss    xmm1,xmm2
        movss    .stvdz12,xmm1

  .stvdx12_done:
        mov     bx,.stvy3       ; calc delta 13
        sub     bx,.stvy1
        jnz     .stvdx13_make
        mov     .stvdx13,0
        mov     .stvdz13,0
        jmp     .stvdx13_done
   .stvdx13_make:
        mov     ax,.stvx3
        sub     ax,.stvx1
        cwde
        movsx   ebx,bx
        shl     eax,ROUND2
        cdq
        idiv    ebx
        mov     .stvdx13,eax

        movss    xmm1,.stvz3
        cvtsi2ss xmm2,ebx
        subss    xmm1,.stvz1
        divss    xmm1,xmm2
        movss    .stvdz13,xmm1

    .stvdx13_done:
        mov     bx,.stvy3       ; calc delta 23
        sub     bx,.stvy2
        jnz     .stvdx23_make
        mov     .stvdx23,0
        mov     .stvdz23,0
        jmp     .stvdx23_done
   .stvdx23_make:
        mov     ax,.stvx3
        sub     ax,.stvx2
        cwde
        movsx   ebx,bx
        shl     eax,ROUND2
        cdq
        idiv    ebx
        mov     .stvdx23,eax

        movss    xmm1,.stvz3
        cvtsi2ss xmm2,ebx
        subss    xmm1,.stvz2
        divss    xmm1,xmm2
        movss    .stvdz23,xmm1

    .stvdx23_done:
        mov     edx,.stvz1

        mov     .stvzz1,edx
        mov     .stvzz2,edx
        movsx   eax,word .stvx1
        shl     eax,ROUND2    ; eax - cur x1
        mov     ebx,eax       ; ebx - cur x2

        mov     cx,.stvy1
        cmp     cx,.stvy2
        jge     .stvloop1_end
     .stvloop1:

        pushad
        sar     ebx,ROUND2
        sar     eax,ROUND2
        movlps  xmm0,.stvzz1
        movaps   xmm2,.y_min
        mov     esi,.stvcnt_buff
        mov     edx,.stvptr_buff
        call    st_sl_var_line

        popad
        add     eax,.stvdx13
        add     ebx,.stvdx12

        movss   xmm1,.stvzz1
        movss   xmm2,.stvzz2
        addss   xmm1,.stvdz13
        addss   xmm2,.stvdz12
        movss   .stvzz1,xmm1
        movss   .stvzz2,xmm2

        add     cx,1
        cmp     cx,.stvy2
        jl      .stvloop1

    .stvloop1_end:

        mov     edx,.stvz2
        mov     .stvzz2,edx
        movsx   ebx,word .stvx2
        shl     ebx,ROUND2

        mov     cx,.stvy2
        cmp     cx,.stvy3
        jge     .stvloop2_end
     .stvloop2:
        pushad

        sar     ebx,ROUND2
        sar     eax,ROUND2
        movlps  xmm0,.stvzz1
        movaps  xmm2,.y_min
        mov     esi,.stvcnt_buff
        mov     edx,.stvptr_buff

        call    st_sl_var_line

        popad

        add     eax,.stvdx13
        add     ebx,.stvdx23

        movss   xmm1,.stvzz1
        movss   xmm2,.stvzz2
        addss   xmm1,.stvdz13
        addss   xmm2,.stvdz23
        movss   .stvzz1,xmm1
        movss   .stvzz2,xmm2


        add     cx,1
        cmp     cx,.stvy3
        jl      .stvloop2
     .stvloop2_end:

        add  esp,128
        pop  ebp

ret

st_sl_var_line:
;----------------------------------------------------
;-------------in xmm0 - lo -> hi z1, z2 -------------
;----------------xmm2 - lo -> hi y_min, y_max, x_min,
;---------------- x_max as dword integers -----------
;--------------- eax - x1 ---------------------------
;--------------- ebx - x2 ---------------------------
;--------------- ecx - y-----------------------------
;--------------- esi - pointer to cnt buff ----------
; -------------- edx - pointer to ptr buff ----------


.slvdz  equ  [ebp-4]
.slvz2  equ  [ebp-8]
.slvz1  equ  [ebp-12]
.slvx2  equ  [ebp-16]
.slvx1  equ  [ebp-20]
.slvptr_buff equ [ebp-24]
.slvcnt_buff equ [ebp-28]
.slvtop_ptr  equ [ebp-32]
.x_max  equ [ebp-34]
.x_min  equ [ebp-36]
.y_max  equ [ebp-38]
.y_min  equ [ebp-40]
;.sli_buff equ [ebp-36]


     push       ebp
     mov        ebp,esp
     sub        esp,64
     or         cx,cx
     jle        .l_quit

     cmp        cx,[yres_var]
     jge        .l_quit
     packssdw   xmm2,xmm2
     movq       .y_min,xmm2
     cmp        cx,.y_min
     jl         .l_quit
     cmp        cx,.y_max
     jge        .l_quit          ;
     movzx      ecx,cx
     mov        .slvcnt_buff,esi
     mov        .slvptr_buff,edx
     cmp        eax,ebx
     je         .l_quit
     jl         .l_ok

     xchg       eax,ebx
     shufps     xmm0,xmm0,11100001b
   .l_ok:

     cmp        ax,.x_max
     jge        .l_quit
     cmp        bx,.x_min
     jle        .l_quit

     movlps     .slvz1,xmm0
     mov        .slvx1,eax
     mov        .slvx2,ebx

     sub        ebx,eax
     movss      xmm0,.slvz2
     cvtsi2ss   xmm1,ebx
     subss      xmm0,.slvz1
     divss      xmm0,xmm1
     movss      .slvdz,xmm0

     movzx      edx,word .x_max
     movzx      ebx,word .slvx1
     cmp        bx, .x_min
     jge        @f              ; clipping
     movzx      eax,word .x_min
     sub        eax,ebx
;     mov        eax,.slvx1
;     neg        eax

     cvtsi2ss   xmm2,eax
     mulss      xmm2,.slvdz
     addss      xmm2,.slvz1
     movss      .slvz1,xmm2
     movzx      eax, word .x_min
     mov        dword .slvx1,eax
;     movzx      edx,word[.x_max]
;     sub        edx,1
   @@:
     cmp        .slvx2,edx
     jl         @f
     mov        .slvx2,edx

    @@:
 ;   mov         eax,.x1
 ;   cmp         .x2,eax
 ;   je          .l_quit
     movzx      edx,word[xres_var]
     mov        edi,.slvptr_buff
     mov        esi, [slices_counter_ptr] ; .cnt_buff
     mov        eax,ecx  ; y
     mul        edx
     add        eax,.slvx1
     add        esi,eax
     shl        eax,2
     add        edi,eax

     mov        ecx,.slvx2
     sub        ecx,.slvx1
     movss      xmm2,.slvz1   ; cz

   .ccalc:
     movzx     ebx,byte[esi]
     or        ebx,ebx       ; inpossible ?
     jz        .update_counters
     mov       edx,[edi]
   .next_sli:
     movss     xmm0,xmm2
     cmpltss   xmm0,[edx]
     movd      eax,xmm0
     cmp       eax,-1
     jne       .update_sli
     mov       eax,edx    ; eax - top
    ; now shift dword variable in [edx]  ebx-1   times

     sub       ebx,1
     jz        .ins_new
     shl       ebx,2
     add       edx,ebx
   @@:
     push      dword[edx-4]
     pop       dword[edx]
     sub       edx,4
     cmp       edx,eax
     jnz       @b
   .ins_new:
     movss     [eax],xmm2  ; insert new value
     jmp       .update_counters
   .update_sli:
     add       edx,4
     sub       ebx,1
     jnz       .next_sli

 .update_counters:
     add       edi,4
     add       esi,1
     addss     xmm2,.slvdz
     sub       ecx,1
     jnz       .ccalc

  .l_quit:
     mov       esp,ebp
     pop       ebp
ret
