
;  rotary about arbitrary vector implemented by Maciej Guba,
;  macgub3@wp.pl , http://macgub.co.pl
;  ebx - normalized vector 3 dwords, each dword coefficient
;  esi - cosinus and sinus of angle
;  edi - desired matrix
make_arbitrary_mx:
 .nx      equ dword[ebx]
 .ny      equ dword[ebx+4]
 .nz      equ dword[ebx+8]
 .sinus   equ dword[esi]
 .cosinus equ dword[esi+4]
 fninit
 fld    dword[ebx]
 fmul   st,st0
 fld    st
 fchs
 fld1
 faddp
 fmul   .cosinus ; dword[esi]
 faddp
 fstp   dword[edi]

 fld    .nx
 fmul   .ny
 fld    .cosinus
 fchs
 fld1
 faddp
 fmulp
 fld    .nz ;dword[ebx+8]
 fmul   .sinus  ;dword[esi]
; fchs
 faddp
 fstp   dword[edi+4]

 fld    .nx
 fmul   .nz
 fld1
 fld    .cosinus
 fchs
 faddp
 fmulp
 fld    .ny
 fmul   .sinus
 fchs
 faddp
 fstp   dword[edi+8]

 fld    .nx
 fmul   .ny
 fld1
 fld    .cosinus
 fchs
 faddp
 fmulp
 fld    .sinus
 fmul   .nz
 fchs
 faddp
 fstp   dword[edi+12]

 fld    .ny
 fmul   st,st0
 fld    st
 fchs
 fld1
 faddp
 fmul   .cosinus
 faddp
 fstp   dword[edi+16]

 fld    .ny
 fmul   .nz
 fld1
 fld    .cosinus
 fchs
 faddp
 fmulp
 fld    .sinus
 fmul   .nx
; fchs
 faddp
 fstp   dword[edi+20]

 fld    .nx
 fmul   .nz
 fld1
 fld    .cosinus
 fchs
 faddp
 fmulp
 fld    .ny
 fmul   .sinus
; fchs
 faddp
 fstp   dword[edi+24]

 fld    .ny
 fmul   .nz
 fld1
 fld    .cosinus
 fchs
 faddp
 fmulp
 fld    .nx
 fmul   .sinus
 fchs
 faddp
 fstp   dword[edi+28]

 fld    .nz
 fmul   st,st0
 fld    st
 fchs
 fld1
 faddp
 fmul  .cosinus
 faddp
 fstp  dword[edi+32]
ret



save3ds:
   pushad
   mov    ebp,esp
   sub    esp,16

    .3dbuffer_ptr    equ [ebp-4]
    .file_handle   equ [ebp-8]
    .bytes_written equ [ebp-12]
    .file_size     equ [ebp-16]
   mov     eax,[points_count_var]
   add     eax,[triangles_count_var] ; to big mem, I know
   add     eax,100
   imul    eax,[i12]
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov    .3dbuffer_ptr,eax

    mov   edi,eax
    mov   [edi],word 4d4dh
    add   edi,6
    mov   [edi],word 3d3dh
    add   edi,6
    mov   [edi],word 4000h
    add   edi,6
    mov   [edi],byte 0
    inc   edi
    mov   [edi],word 4100h     ;    [global_points_counter]
    add   edi,6
    mov   [edi],word 4110h
    mov   ecx,[points_count_var]

    mov   edx,ecx
    mov   [edi+6],cx
    add   edi,8
    mov   esi,[points_rotated_ptr];   [points_r_ptr]   ;
    xor   ebx,ebx
    lea   ecx,[ecx*3]
  @@:
    rep   movsd
    mov   [edi],word 4120h
    mov   ecx,[triangles_count_var]
    mov   [edi+6],cx
    add   edi,8
    mov   esi,[triangles_ptr]
    cld
  @@:
    movdqu    xmm0,[esi]
    packssdw  xmm0,xmm0
    movq      [edi],xmm0
    mov       dword[edi+6],0
    add       esi,12
    add       edi,8
    loop      @b
    mov       ebx,.3dbuffer_ptr
    sub       edi,.3dbuffer_ptr
    mov       [ebx+2],edi
    mov       .file_size,edi
    invoke    CreateFile,Bfile_name, GENERIC_WRITE, 0, 0,CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
    mov       .file_handle,eax
    invoke    WriteFile,eax,.3dbuffer_ptr,.file_size,byteswritten, 0
    invoke    CloseHandle,.file_handle
    invoke    VirtualFree,.3dbuffer_ptr,0 , MEM_RELEASE

    mov       esp,ebp
    popad
ret
