delete_chunk:
; in eax - chunks No to delete
; Need perform remove dead triangles and remove
; unused vertices at the end of process.
  mov    esi,[chunks_ptr]
  mov    ecx,[triangles_count_var]
  mov    edi,[triangles_ptr]
  pxor   xmm0,xmm0
 .nxx:
  cmp    [esi],ax
  jne    @f
  movq   [edi],xmm0
  movd   [edi+8],xmm0
 @@:
  add    esi,2
  add    edi,12
  loop   .nxx
ret

;============================================================

invert_normals_ch:
; invert sense of normal vectors of selected chunk;
; in eax - index number of selected chunk

  mov    esi,[chunks_ptr]
  mov    ecx,[triangles_count_var]
  mov    edi,[triangles_ptr]
 .nxx:
  cmp    [esi],ax
  jne    @f
  movq   xmm0,[edi]
  pshufd xmm0,xmm0,11100001b
  movq   [edi],xmm0
 @@:
  add    esi,2
  add    edi,12
  loop   .nxx
ret
;==================================================================
detect_chunks:
    push ebp
    mov  ebp,esp
    and  ebp,-16
    sub  esp,60
   .tri_ChunL      equ  dword[ebp-4]    ; tri chunks list ptr
   .chunks         equ  dword[ebp-8]    ; chunks ptreach tri chunk No. as word
   .tri_ChunLCnt   equ  dword[ebp-12]
   .chunks_cnt     equ  dword[ebp-16]
   .sst            equ  dword[ebp-20]   ; store mark
   .cur_ch_ptr     equ  dword[ebp-24]   ; current chunk ptr
   .ch_cnt         equ  dword[ebp-28]   ; "global" chunks counter
   .cur_tCLptr     equ  dword[ebp-32]   ; current tri chunks list pointer
   .std_ptr        equ  dword[ebp-36]   ; marks of stored triangles list

   prompt  prompt_det_chunks ; macro

   mov     ebx,[triangles_count_var]
   shl     ebx,2
   lea     ebx,[ebx*3]
   add     ebx,32
   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .tri_ChunL,eax
   mov     .cur_tCLptr,eax

   mov     ebx,[triangles_count_var]
   shl     ebx,1
   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .chunks,eax     ; each tri chunk No. as word
   mov     .cur_ch_ptr,eax
   mov     .ch_cnt,0

   shr     ebx,1
   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .std_ptr,eax     ; each tri chunk No. as word

   mov     ecx,[points_count_var]
   mov     edi,eax
   xor     eax,eax
   shr     ecx,2
   add     ecx,1
   call    fill_aligned

   mov    esi,[triangles_ptr]
   mov    ecx,[triangles_count_var] ; triangles chunks list counter
   mov    edx,.std_ptr              ; mark of stored tri list
   mov    edi,.tri_ChunL            ; tri chunks list ptr

  .nx_chunk:
   mov     .sst,0           ; store mark
   mov     .tri_ChunLCnt,1  ; triangles count in one chunk
   inc     .ch_cnt          ; chunk counter
   movdqu  xmm0,[esi]       ; init chunks tris list
   mov     edi,.cur_tCLptr  ; current tri chunks list pointer
   movdqu  [edi],xmm0
   mov     [edx],byte 1
;   inc     edx
   add     .cur_tCLptr,12
   mov     ebx,.cur_ch_ptr
   mov     eax,.ch_cnt
   mov     [ebx],ax
   add     .cur_ch_ptr,2
   dec     ecx
   jz      .end
;   mov     ebx,.cur_ch_ptr
;   mov     eax,.ch_cnt
;   mov     [ebx],ax
;   add     .cur_ch_ptr,2
;;   dec     ecx
;;   jz      .end       ; pararell to esi = Triangles Chunk List

 ;  sub     .tri_ChunLCnt,2

  .nx_edi:
   push    ecx
   push    esi
   push    edx
  .nx_L:
   movdqu  xmm0,[edi]
   movdqu  xmm1,[esi]
   movd    xmm2,[esi]
   movd    xmm3,[esi+4]
   movd    xmm4,[esi+8]
   pshufd  xmm2,xmm2,0
   pshufd  xmm3,xmm3,0
   pshufd  xmm4,xmm4,0
   pcmpeqd xmm2,xmm0
   pcmpeqd xmm3,xmm0
   pcmpeqd xmm4,xmm0
   por     xmm2,xmm3
   por     xmm2,xmm4
   movmskps eax,xmm2
   and     eax,111b
   cmp     eax,111b
   je      @f       ; the same triangle
;   popcnt  eax,eax
;   cmp     eax,2
   cmp     eax,101b
   je     .store
   cmp     eax,011b
   je     .store
   cmp     eax,110b
   je     .store

 ;  or      eax,eax
 ;  jnz     .store
  @@:
  .nxCh:            ; dec counter of inner loop
   add     esi,12
   inc     edx
   loop    .nx_L    ; next on the list
   jmp     .isEL    ; is end of loop ?

  .store:
   cmp     byte[edx],1  ; if byte [edx] = 1 ; tri was stored
   je      .nxCh
   inc     .tri_ChunLCnt
   mov     ebx,.cur_tCLptr
   movdqu  [ebx],xmm1
   add     .cur_tCLptr,12
   mov     ebx,.cur_ch_ptr
   mov     eax,.ch_cnt
   mov     [ebx],ax
   add     .cur_ch_ptr,2
   mov     byte[edx],1
   mov     .sst,1
   jmp       .nxCh

  .isEL:
   add     edi,12
   pop     edx
   pop     esi
   pop     ecx
   cmp     .sst,0
   je      @f         ; without store
   dec     .tri_ChunLCnt
   jnz     .nx_edi

 @@:
   mov     esi,.chunks
   xor     ecx,ecx
 @@:
   cmp     word[esi],0
   je      @f
   add     esi,2
   inc     ecx
   cmp     ecx,[triangles_count_var]
   jnz     @b
   jmp     .end            ; all chunks detected
 @@:
   jecxz   .end
   mov     esi,ecx
   mov     ebx,ecx
   mov     edx,ecx
   sub     ecx,[triangles_count_var]
   neg     ecx
   inc     ecx
   imul    esi,[i12]
   shl     ebx,1
   add     esi,[triangles_ptr]
   add     ebx,.chunks
   add     edx,.std_ptr
   mov     .cur_ch_ptr,ebx
   ;  inc     .ch_cnt
   jmp     .nx_chunk
  .end:
   mov    ebx,.chunks
   mov    ecx,.ch_cnt
 ;  dec    ecx

   cls    ; macro

   add    esp,60
   pop    ebp
ret
;------------------------------------------------------------------------
