
Bputpixel:   ; Next Mesh edit
; in: eax - x + y shl 16
;     cl  - markup
;     esi - color 0x00rrggbb
  emms
  mov     ebx,(BYRES-5) shl 16 +BXRES-5
  movd    mm0,ebx
  mov     ebx,5 shl 16 +5
  movd    mm1,ebx
  movd    mm2,eax
  pmaxsw  mm2,mm1
  pminsw  mm2,mm0

  movd   eax,mm2
  mov    edx,BXRES
  movzx  ebx,ax
  shr    eax,16
  mul    edx
  add    eax,ebx
  shl    eax,2
  add    eax,Bbuffer

  mov     edi,eax              ; draw line handle
  and     esi,0x00ffffff
  mov     al,cl                ; cl -> crucial point number
  shl     eax,24
  or      eax,esi
;  cmp     cl,253
;  jae     .axis
;  or      eax,0x00ff0000
;  jmp     .draw
; .axis:
;  or      eax,0x0000ffff
; .draw:
  sub     edi,2*BXRES*4+20
  mov     ecx,5
  cld
  rep     stosd
  add     edi,BXRES*4-20
  mov     ecx,5
  rep     stosd
  add     edi,BXRES*4-20
  mov     ecx,5
  rep     stosd
  add     edi,BXRES*4-20
  mov     ecx,5
  rep     stosd
  add     edi,BXRES*4-20
  mov     ecx,5
  rep     stosd

  emms
ret

NextMdraw_all:  ;   Next Mesh edit

;in  eax - dword value to fill,
;    ecx - area size in dwords
;    edi - mem adress
;    addres must be aligned
     mov   ecx,BXRES * BYRES
     mov   eax,0xff1f1f1f
     mov   edi,Bbuffer
     call  fill_aligned

 ;    movq   xmm0,[NextMxadd]  ; x, y, z
 ;    packssdw xmm0,xmm0
;     psrlw   xmm0,1
;     mov     ebx,((BYRES shr 1) shl 16) + (BXRES shr 1)
;     movd    xmm1,ebx
;     paddusw xmm0,xmm1
     mov     eax,[NextMxadd]  ;xmm0
     mov     cl,1
     mov     esi,0x0000ffff
     call    Bputpixel  ; write bar on Bbuffer area
     mov     ax,[NextMzadd]
     shl     eax,16
     mov     ax,5
     mov     cl,2
     mov     esi,0x00ff00ff
     call    Bputpixel  ; write bar on Bbuffer area
     mov     ax,[NextScale]
     shl     eax,16
     mov     ax,BXRES - 10
     mov     cl,3
     mov     esi,0x00ffff00
     call    Bputpixel  ; write bar on Bbuffer area
     mov     eax,[NextRotate]
   ;  sub     eax,10 shl 16 + 10
     mov     cl,4
     mov     esi,0x00ff0f0f
     call    Bputpixel  ; write bar on Bbuffer area

ret



;------------------------------------------------------------------------
write_info:   ; Display unique edges, vertices, faces count, colided edges
              ; and individual chunks info.
    push ebp
    mov  ebp,esp
    sub  esp,100

    .str_ed   equ  [ebp-100]
;    .str_vert equ  [ebp-100]

    xor    eax,eax          ; clear draw buffer
    mov    edi,info_screen
    mov    ecx,INFOX * INFOY
    call   fill_aligned
    mov    eax,5 shl 16 + 2
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    mov    esi,uniq_ed
    mov    edi,info_screen
    call   write_text
; unsigned dword integer to ascii procedure
;     in   eax - variable
;          esi - Pointer to ascii string
;   out    esi - desired ascii string
;          edi - end of ascii string  - ptr to memory

    mov    eax,[edges_count]
    lea    esi,.str_ed
    call   itoa
    mov    byte[edi+1],0

;   eax - x * 65536 + y -> where to display
;   ebx - pointer to character table
;   ecx - size x * 65536 + size y -> size of scr buffer
;   esi - pointer to ASCIIZ string to display
;   edi - pointer to scr buffer
    mov    eax,5 shl 16 + 19
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    lea    esi,.str_ed
    mov    edi,info_screen
    call   write_text


    mov    eax,5 shl 16 + 36
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    mov    esi,faces
    mov    edi,info_screen
    call   write_text

    mov    eax,[triangles_count_var]
    lea    esi,.str_ed
    call   itoa
    mov    byte[edi+1],0

    mov    eax,5 shl 16 + 36 + 17
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    lea    esi,.str_ed
    mov    edi,info_screen
    call   write_text

    mov    eax,5 shl 16 + 36 + 17*2
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    mov    esi,vertices
    mov    edi,info_screen
    call   write_text

    mov    eax,[points_count_var]
    lea    esi,.str_ed
    call   itoa
    mov    byte[edi+1],0

    mov    eax,5 shl 16 + 36 + 3*17
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    lea    esi,.str_ed
    mov    edi,info_screen
    call   write_text

    cmp    [mark_coll_ed_flag],0
    je     @f

    mov    eax,5 shl 16 + 36 + 17*4
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    mov    esi,edges_inter
    mov    edi,info_screen
    call   write_text

    mov    eax,[edges_coll_count]  ; edges collided count
    lea    esi,.str_ed
    call   itoa
    mov    byte[edi+1],0

    mov    eax,5 shl 16 + 36 + 17*5
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    lea    esi,.str_ed
    mov    edi,info_screen
    call   write_text
  @@:

    cmp    [srch_chunk_flag],0
    je     @f

    mov    eax,200 shl 16 + 17*0
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    mov    esi,chunks_info
    mov    edi,info_screen
    call   write_text

    mov    eax,[chunks_count]  ; edges collided count
    lea    esi,.str_ed
    call   itoa
    mov    byte[edi+1],0

    mov    eax,200 shl 16 + 18
    mov    ebx,font_table + 62
    mov    ecx,INFOX shl 16 + INFOY
    lea    esi,.str_ed
    mov    edi,info_screen
    call   write_text
  @@:



    movzx  eax,[xres_var]
    mov    ebx,MYPRES
    add    ebx,2
    invoke StretchDIBits,[hdc],eax,ebx,INFOX,INFOY,0,0,INFOX,INFOY,info_screen,Ibmi,0,SRCCOPY

    mov  esp,ebp
    pop  ebp
ret

;======================================================
normalize_plane_equation:
 movups xmm0,[plane_equation]    ;normalize
 movaps xmm1,xmm0
; andps  xmm0,[zero_hgst_dd]
 mulps  xmm0,xmm0
 haddps xmm0,xmm0
 haddps xmm0,xmm0
; shufps xmm0,xmm0,00000000b
 rsqrtps xmm0,xmm0
 mulps  xmm1,xmm0     ; xmm1 - normalized plane equat.
 movups [plane_equation],xmm1
ret

;=========================================================
fill_aligned:
;in  eax - dword value to fill,
;    ecx - area size in dwords
;    edi - mem adress
;    addres must be aligned
    mov  ebx,ecx
    and  ebx,1111b  ;
    jz   .fill_sse
  @@:
    mov  [edi],eax
    add  edi,4
    sub  ebx,1
    jnz  @b
  .fill_sse:
    shr    ecx,4
    or     ecx,ecx
    jz     .end
    movd   xmm0,eax
    shufps xmm0,xmm0,0
    and    edi,-16 ; to be sure
  @@:
    movaps  [edi],xmm0
    movaps  [edi+16],xmm0
    movaps  [edi+32],xmm0
    movaps  [edi+48],xmm0
    add     edi,64
    loop    @b
   .end:
ret

;===========================================================
norm_aligned_lv:     ; normalise aligned light vectors
;  in edi -> lights_ptr
;     ecx -> lights count
    @@:
     movaps  xmm0,[edi]
     movaps  xmm1,[edi]
     mulps   xmm1,xmm1
     haddps  xmm1,xmm1
     haddps  xmm1,xmm1
     rsqrtps xmm1,xmm1
     mulps   xmm0,xmm1
     movaps  [edi],xmm0
     add     edi,64
     sub     ecx,1
     jnz     @b
ret