;-procedure draws textured line with z coordinate interpolation-----
;-author: Maciej Guba (www.macgub.co.pl)-------------------------
;-in : -------------------------------------------------------------
;----- edi - pointer to screen buffer ------------------------------
;----- esi - pointer to Z buffer -----------------------------------
;----- edx - pointer to texture buffer -----------------------------
;------ constans : SIZE_X, SIZE_Y - screen width and height---------
;----------------- ROUND - fixed point shift------------------------
;------ other parameters via stack----------------------------------

tex_line:
.x1	 equ  ebp+4
.y1	 equ  ebp+6
.z1	 equ  ebp+8
.tex_x1  equ  ebp+10
.tex_y1  equ  ebp+12
.x2	 equ  ebp+14
.y2	 equ  ebp+16
.z2	 equ  ebp+18
.tex_x2  equ  ebp+20
.tex_y2  equ  ebp+22



.line_lenght	equ ebp-2
.delta		equ ebp-6
.delta_x	equ ebp-10
.delta_y	equ ebp-14
.dtex_x 	equ ebp-18
.dtex_y 	equ ebp-22
.dz		equ ebp-26
.ctex_x 	equ ebp-30
.ctex_y 	equ ebp-34
.cz		equ ebp-38

;.line_lenght	 equ ebp-48
.screen 	equ ebp-42
.zbuffer	equ ebp-46
.ccoord 	equ ebp-50  ;current coordinate
.czbuf		equ ebp-54
.cscr		equ ebp-58
.tex_buffer	equ ebp-62
;.lasty 	 equ ebp-72
macro .update_cur_var
{
;     movq	  mm0,[.cz]    ; .z and .y at once
;     paddd	  mm0,[.dz]
;     movq	  [.cz],mm0
     mov	 eax,[.dz]
     mov	 ebx,[.dtex_x]
     mov	 edx,[.dtex_y]
     add	 [.cz],eax
     add	 [.ctex_x],ebx
     add	 [.ctex_y],edx

}
macro .draw_pixel
{
    mov 	[esi],ebx	       ; actualize Z buffer

    mov 	eax,[.ctex_y]
    sar 	eax,ROUND
    shl 	eax,TEX_SHIFT

    mov 	ebx,[.ctex_x]
    sar 	ebx,ROUND
    add 	eax,ebx
    and 	eax,TEXTURE_SIZE
    shl 	eax,2

    add 	eax,[.tex_buffer]
    mov 	eax,[eax]
    mov 	[edi],eax

}
macro .sort
{

if Ext >= MMX
    movq	mm0,[.x1]
    movq	mm1,[.x2]
    movq	[.x1],mm1
    movq	[.x2],mm0
else
    mov 	edx,[.x1]
    xchg	edx,[.x2]
    mov 	[.x1],edx
    mov 	edx,[.z1]
    xchg	edx,[.z2]
    mov 	[.z1],edx
end if
    mov 	dx,[.tex_y1]
    xchg	dx,[.tex_y2]
    mov 	[.tex_y1],dx
}

    emms
    mov 	ebp,esp
    sub 	esp,128
    mov 	eax,[.x1]      ; check if parameters exceedes screen area
    mov 	ebx,[.x2]
    or		eax,ebx
    test	eax,80008000h
    jne 	.end_line
    mov 	cx,[xres_var]
    dec 	cx
    cmp 	word[.x1],cx  ;SIZE_X
    jg		.end_line
    cmp 	word[.x2],cx  ;SIZE_X
    jg		.end_line
    mov 	cx,[yres_var]
    dec 	cx
    cmp 	word[.y1],cx  ;SIZE_Y
    jg		.end_line
    cmp 	word[.y2],cx   ;SIZE_Y
    jg		.end_line


    mov 	[.screen],edi
    mov 	[.tex_buffer],edx
    mov 	cx,[.x1]
    cmp 	cx,[.x2]
    je		.vertical_l
    mov 	cx,[.y1]
    cmp 	cx,[.y2]
    je		.horizontal_l
    mov 	ax,[.x1]
    sub 	ax,[.x2]
    cmp 	ax,0
    jg		@f
    neg 	ax    ; calc absolute value
 @@:
    mov 	[.delta_x],ax
    mov 	bx,[.y1]
    sub 	bx,[.y2]
    cmp 	bx,0
    jg		@f
    neg 	bx
 @@:
    mov 	[.delta_y],bx
    cmp 	ax,bx
    je		.deg45_l
    jl		.more_vertical_l
    jg		.more_horizon_l
    jmp 	.end_line
								  ;
.horizontal_l:
    mov 	ax,[.x1]
    mov 	bx,[.x2]
    cmp 	bx,ax
    jge 	@f

    .sort
@@:

    mov 	bx,[.x2]
    sub 	bx,[.x1]
    movzx	ebx,bx
    cmp 	ebx,0	 ;line lenght equal 0
    je		.end_line
    mov 	[.delta_x],ebx

    call	.calc_delta

    movzx	eax,[xres_var]	;SIZE_X
    movzx	ebx,word[.y1]
    mul 	ebx
    movzx	ebx,word[.x1]
    add 	eax,ebx
    shl 	eax,2		    ; esi - z buffer
    add 	esi,eax 	    ; edi - screen buffer
    add 	edi,eax

    mov 	ecx,[.delta_x]

    movsx	ebx,word[.tex_x1]
    shl 	ebx,ROUND
    mov 	[.ctex_x],ebx
    movsx	eax,word[.tex_y1]
    shl 	eax,ROUND
    mov 	[.ctex_y],eax
    movsx	edx,word[.z1]
    shl 	edx,ROUND
    mov 	[.cz],edx
.hdraw:
    mov 	ebx,[.cz]

    cmp 	[esi],ebx
    jle 	.skip

    .draw_pixel

.skip:
    add 	edi,4
    add 	esi,4

    .update_cur_var

    loop	.hdraw
    jmp 	.end_line

.vertical_l:
    mov 	ax,[.y1]
    cmp 	[.y2],ax
    jge 	@f

    .sort
@@:
    mov 	bx,[.y2]
    sub 	bx,[.y1]
    movsx	ebx,bx
    cmp 	ebx,0
    je		.end_line
    mov 	[.delta_y],ebx

    call	.calc_delta

    movzx	eax,[xres_var]	;SIZE_X
    movsx	ebx,word[.y1]
    mul 	ebx
 ;   add	 esi,eax
 ;   lea	 eax,[eax*3]
    shl 	eax,2
    add 	edi,eax
    add 	esi,eax
    movsx	eax,word[.x1]
;    add	 esi,eax
;    lea	 eax,[eax*3]
    shl 	eax,2
    add 	esi,eax
    add 	edi,eax

    mov 	ecx,[.delta_y]

    movsx	ebx,word[.tex_x1]
    shl 	ebx,ROUND
    mov 	[.ctex_x],ebx
    movsx	ebx,word[.tex_y1]
    shl 	ebx,ROUND
    mov 	[.ctex_y],ebx
    movsx	ebx,word[.z1]
    shl 	ebx,ROUND
    mov 	[.cz],ebx

.v_draw:
    mov 	ebx,[.cz]

    cmp 	[esi],ebx
    jle 	@f

    .draw_pixel

@@:
    movzx	eax,[xres_var]
    shl 	eax,2
    add 	edi,eax  ;SIZE_X*4
    add 	esi,eax   ;SIZE_X*4

    .update_cur_var

    loop	.v_draw
    jmp 	.end_line
.deg45_l:
    mov 	word[.line_lenght],ax
    mov 	ax,[.x1]
    cmp 	[.x2],ax
    jge 	@f

    .sort
@@:
    mov 	bx,[.y2]
    sub 	bx,[.y1]
    movsx	ebx,bx
    cmp 	ebx,0
    je		.end_line
    mov 	[.delta_y],ebx
    mov 	bx,[.x2]
    sub 	bx,[.x1]
    movsx	ebx,bx
    mov 	[.delta_x],ebx

    call	.calc_delta

    movzx	eax,[xres_var]	;SIZE_X
    movsx	ebx,word[.y1] ;calc begin values in screen and Z buffers
    mul 	ebx
;    lea	 ebx,[3*eax]
;    add	 edi,ebx
    shl 	eax,2
    add 	edi,eax
    add 	esi,eax
    movsx	eax,word[.x1]
;    lea	 ebx,[eax*3]
;    add	 edi,ebx
    shl 	eax,2
    add 	edi,eax
    add 	esi,eax

    movzx	ecx,word[.line_lenght]

    movsx	eax,word[.tex_x1]
    shl 	eax,ROUND
    mov 	[.ctex_x],eax
    movsx	ebx,word[.tex_y1]
    shl 	ebx,ROUND
    mov 	[.ctex_y],ebx
    movsx	edx,word[.z1]
    shl 	edx,ROUND
    mov 	[.cz],edx
.d45_draw:
    mov 	ebx,[.cz]

    cmp 	[esi],ebx
    jle 	@f

    .draw_pixel

@@:
    movzx	eax,[xres_var]
    cmp 	dword[.delta_y],0
    jl		@f
    lea 	eax,[eax*4+4]
    add 	edi,eax  ;SIZE_X*4+4
    add 	esi,eax   ;SIZE_X*4+4
    jmp 	.d45_1
@@:
    lea 	eax,[eax*4-4]
    sub 	edi,eax  ;(SIZE_X*4)-4
    sub 	esi,eax  ;(SIZE_X*4)-4
.d45_1:
    .update_cur_var

    loop	.d45_draw
    jmp 	.end_line

.more_vertical_l:
    mov 	word[.line_lenght],bx
    mov 	ax,[.y1]
    cmp 	[.y2],ax
    jge 	@f
    .sort
@@:
    mov 	bx,[.y2]
    sub 	bx,[.y1]
    movsx	ebx,bx
    cmp 	ebx,0
    je		.end_line
    mov 	[.delta_y],ebx

    mov 	ax,[.x2]
    sub 	ax,[.x1]
    cwde
    shl 	eax,ROUND
    cdq
    idiv	ebx
    mov 	[.delta],eax

    call	.calc_delta

    movzx	eax,[xres_var]	;SIZE_X
    movsx	ebx,word[.y1] ;calc begin values in screen and Z buffers
    mul 	ebx
  ;  lea	 ebx,[3*eax]
  ;  add	 esi,ebx
    shl 	eax,2
    add 	esi,eax
    add 	edi,eax
    mov 	[.cscr],edi
    mov 	[.czbuf],esi

    movzx	ecx,word[.line_lenght]

    movsx	ebx,word[.tex_x1]
    shl 	ebx,ROUND
    mov 	[.ctex_x],ebx
    movsx	ebx,word[.tex_y1]
    shl 	ebx,ROUND
    mov 	[.ctex_y],ebx
    movsx	ebx,word[.z1]
    shl 	ebx,ROUND
    mov 	[.cz],ebx

    movsx	ebx,word[.x1]
    shl 	ebx,ROUND
    mov 	[.ccoord],ebx	 ; .ccoord -> x coordinate
.draw_m_v:
    mov 	edi,[.cscr]
    mov 	esi,[.czbuf]
    mov 	eax,[.ccoord]
    sar 	eax,ROUND
 ;   lea	 ebx,[eax*3]
    shl 	eax,2
    add 	edi,eax
;    add	 esi,ebx
    add 	esi,eax

    cmp 	[esi],ebx
    jle 	@f

    .draw_pixel

@@:
    mov 	eax,[.delta]
    add 	[.ccoord],eax
    movzx	eax,[xres_var]
    shl 	eax,2
    add 	dword[.cscr],eax   ;SIZE_X*4  ;
    add 	dword[.czbuf],eax   ;SIZE_X*4
.d_m_v1:

    .update_cur_var

    dec 	ecx
    jnz 	.draw_m_v
    jmp 	.end_line

.more_horizon_l:
    mov 	word[.line_lenght],ax
    mov 	ax,[.x1]
    cmp 	[.x2],ax
    jge 	@f

    .sort
@@:
    mov 	bx,[.x2]
    sub 	bx,[.x1]
    movsx	ebx,bx
    cmp 	ebx,0;=======================
    je		.end_line
    mov 	[.delta_x],ebx

    mov 	ax,[.y2]
    sub 	ax,[.y1]
    cwde
    shl 	eax,ROUND
    cdq
    idiv	ebx
    mov 	[.delta],eax

    call	.calc_delta

 ;calc begin values in screen and Z buffers
    movsx	ebx,word[.x1]
    mov 	eax,ebx
  ;  add	 esi,ebx
  ;  lea	 ebx,[3*ebx]
    shl 	ebx,2
    add 	esi,ebx
    add 	edi,ebx
    mov 	[.cscr],edi
    mov 	[.czbuf],esi

    movzx	ecx,word[.line_lenght]

    movsx	ebx,word[.tex_x1]
    shl 	ebx,ROUND
    mov 	[.ctex_x],ebx
    movsx	ebx,word[.tex_y1]
    shl 	ebx,ROUND
    mov 	[.ctex_y],ebx
    movsx	ebx,word[.z1]
    shl 	ebx,ROUND
    mov 	[.cz],ebx
    movsx	ebx,word[.y1]
    shl 	ebx,ROUND
    mov 	[.ccoord],ebx	 ; .ccoord -> y coordinate

.draw_m_h:
    mov 	edi,[.cscr]
    mov 	esi,[.czbuf]
    mov 	eax,[.ccoord]	 ; ccoord - cur y coordinate
    sar 	eax,ROUND
    movzx	ebx,[xres_var]	;SIZE_X
    mul 	ebx
 ;   add	 esi,eax
 ;   lea	 eax,[eax*3]
    shl 	eax,2
    add 	esi,eax
    add 	edi,eax
if  0 ;Ext >= SSE2
    movd	ebx,xmm1
else
    mov 	ebx,[.cz]
end if
    cmp 	[esi],ebx
    jle 	@f

    .draw_pixel

@@:
    mov 	eax,[.delta]
    add 	[.ccoord],eax
    add 	dword[.cscr],4	;
    add 	dword[.czbuf],4

    .update_cur_var

    dec 	ecx
    jnz 	.draw_m_h

.end_line:
     mov       esp,ebp
     ret       20

.calc_delta:
    mov 	ax,[.z2]
    sub 	ax,[.z1]
    cwde
    shl 	eax,ROUND
    cdq
    idiv	ebx
    mov 	[.dz],eax

    mov 	ax,[.tex_x2]
    sub 	ax,[.tex_x1]
    cwde
    shl 	eax,ROUND
    cdq
    idiv	ebx
    mov 	[.dtex_x],eax

    mov 	ax,[.tex_y2]
    sub 	ax,[.tex_y1]
    cwde
    shl 	eax,ROUND
    cdq
    idiv	ebx
    mov 	[.dtex_y],eax

ret














